'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormValidatorField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _Context = require('./Context');

var _Context2 = _interopRequireDefault(_Context);

var _Message = require('./Message');

var _Message2 = _interopRequireDefault(_Message);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormValidatorField = exports.FormValidatorField = function (_Component) {
  _inherits(FormValidatorField, _Component);

  function FormValidatorField() {
    _classCallCheck(this, FormValidatorField);

    return _possibleConstructorReturn(this, (FormValidatorField.__proto__ || Object.getPrototypeOf(FormValidatorField)).apply(this, arguments));
  }

  _createClass(FormValidatorField, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          name = _props.name,
          otherProps = _objectWithoutProperties(_props, ['children', 'className', 'name']);

      var _context$errors = this.context.errors,
          errors = _context$errors === undefined ? {} : _context$errors;

      var classes = (0, _classnames2.default)('inloco-form-validator__field', className);
      return _react2.default.createElement(
        _semanticUiReact.Form.Field,
        _extends({
          className: classes,
          name: name,
          error: !!errors[name]
        }, otherProps),
        children,
        _react2.default.createElement(_Message2.default, { message: errors[name] })
      );
    }
  }]);

  return FormValidatorField;
}(_react.Component);

FormValidatorField.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired
};
FormValidatorField.contextType = _Context2.default;
exports.default = FormValidatorField;