'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormValidator = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _Context = require('./Context');

var _Context2 = _interopRequireDefault(_Context);

var _Field = require('./Field');

var _Field2 = _interopRequireDefault(_Field);

var _Message = require('./Message');

var _Message2 = _interopRequireDefault(_Message);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormValidator = exports.FormValidator = function (_Component) {
  _inherits(FormValidator, _Component);

  function FormValidator() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FormValidator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormValidator.__proto__ || Object.getPrototypeOf(FormValidator)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FormValidator, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          onSubmitSuccess = _props.onSubmitSuccess,
          validate = _props.validate,
          value = _props.value,
          otherProps = _objectWithoutProperties(_props, ['children', 'className', 'onSubmitSuccess', 'validate', 'value']);

      var errors = this.state.errors;

      var classes = (0, _classnames2.default)('inloco-form-validator', className);
      return _react2.default.createElement(
        _semanticUiReact.Form,
        _extends({ className: classes }, otherProps, { onSubmit: this.handleSubmit }),
        _react2.default.createElement(
          _Context2.default.Provider,
          { value: { errors: errors } },
          children
        )
      );
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.hasErrors()) {
        this.revalidateExistingErrors();
      }
    }
  }, {
    key: 'getFieldsWithError',
    value: function getFieldsWithError() {
      var errors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.errors;

      return Object.keys(errors).filter(function (fieldName) {
        return errors[fieldName];
      });
    }
  }, {
    key: 'hasErrors',
    value: function hasErrors(errors) {
      return this.getFieldsWithError(errors).length > 0;
    }
  }, {
    key: 'revalidateExistingErrors',
    value: function revalidateExistingErrors() {
      var errors = this.state.errors;


      var fieldsWithError = this.getFieldsWithError();
      var newErrors = this.validate();

      var haveErrorsChanged = false;
      fieldsWithError.forEach(function (fieldName) {
        if (errors[fieldName] && !newErrors[fieldName]) {
          errors[fieldName] = newErrors[fieldName];
          haveErrorsChanged = true;
        }
      });
      if (haveErrorsChanged) {
        this.setState({ errors: errors });
      }
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _props2 = this.props,
          validate = _props2.validate,
          value = _props2.value;

      return validate(value) || {};
    }
  }]);

  return FormValidator;
}(_react.Component);

FormValidator.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  onSubmit: _propTypes2.default.func,
  onSubmitSuccess: _propTypes2.default.func,
  validate: _propTypes2.default.func.isRequired,
  value: _propTypes2.default.object.isRequired
};
FormValidator.Context = _Context2.default;
FormValidator.Field = _Field2.default;
FormValidator.Message = _Message2.default;

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.state = {
    errors: {}
  };

  this.handleSubmit = function () {
    var _props3 = _this2.props,
        onSubmit = _props3.onSubmit,
        onSubmitSuccess = _props3.onSubmitSuccess;

    onSubmit && onSubmit.apply(undefined, arguments);

    var errors = _this2.validate();
    _this2.setState({ errors: errors });
    if (!_this2.hasErrors(errors) && onSubmitSuccess) {
      onSubmitSuccess();
    }
  };
};

exports.default = FormValidator;